MODULE_NAME='TOA_D901_UI' (DEV vdvTOA_D901, DEV dvTP, INTEGER nBUTTONS[], INTEGER nTEXT[], INTEGER nLEVELS[])

(********************************************************************)
(* FILE CREATED ON: 09/07/04  AT: 15:37:38                          *)
(********************************************************************)
(********************************************************************)
(*  FILE_LAST_MODIFIED_ON: 09/07/04 AT: 15:37:38           *)
(***********************************************************)
(*  ORPHAN_FILE_PLATFORM: 1                                *)
(***********************************************************)
(*!!FILE REVISION: Rev 0                                   *)
(*  REVISION DATE: 09/07/04                                *)
(*                                                         *)
(*  COMMENTS:  This sample User Interface supports only API level values and does not 
            implement all the features supported by the Communication module. Please feel free
            to modify this code according to you installation needs. 
		The sample User Interface and touch panel file are provided as an example and there is
	    no expectation that they will be used as is in an actual installation.    CNina,AMX 2004  *)
(*                                                         *)
(***********************************************************)
(*}}PS_SOURCE_INFO                                         *)
(***********************************************************)

DEFINE_CONSTANT

INTEGER MAX_INPUTS = 12
INTEGER MAX_OUTPUTS= 8
(********************************************************************)
DEFINE_VARIABLE

VOLATILE INTEGER nInputSelected  = 1 // stores the currenly selected input
VOLATILE INTEGER nOutputSelected = 1 // stores the currenly selected output
VOLATILE INTEGER nMatrixInputSelected = 1 // stores the currenly selected matrix input
VOLATILE INTEGER nSelection = 0 // stores the index of the button selected by user from the button array
VOLATILE INTEGER bDeviceScale = 0 // stores the current scale selected (default is API=0)
VOLATILE INTEGER bDebug = 0    // stores the state of the debug feature
VOLATILE INTEGER nInputLevel[MAX_INPUTS] // stores the Gain level for each input
VOLATILE INTEGER nInputMute[MAX_INPUTS]  // stores the Mute state of each input
VOLATILE INTEGER nOutputLevel[MAX_OUTPUTS] // stores the Gain level for each output
VOLATILE INTEGER nOutputMute[MAX_OUTPUTS] // stores the Mute state of each output
VOLATILE INTEGER nMatrixLevel[MAX_INPUTS][MAX_OUTPUTS] // stores the Gain level for each cross-point in the Matrix
VOLATILE INTEGER nPreset = 0 // stores the preset number last recalled.
(********************************************************************)
// This function updates all 8 output levels according to whatever Input is selected for the Matrix cross-point. 
DEFINE_FUNCTION fnUpdateMatrixOutputs(INTEGER nIn)
{
    STACK_VAR INTEGER nCnt
    FOR(nCnt=1;nCnt<=MAX_OUTPUTS;nCnt++)
	SEND_COMMAND dvTP,"'@TXT',nText[3+nCnt],ITOA(nMatrixLevel[nIn][nCnt])"
}
(********************************************************************)
DEFINE_FUNCTION fnClearTextBoxes()
{
    STACK_VAR INTEGER nCnt
    FOR(nCnt=1;nCnt<=13;nCnt++)
	SEND_COMMAND dvTP,"'@TXT',nText[nCnt],''"
}
(********************************************************************)
DEFINE_START



(********************************************************************)
DEFINE_EVENT

DATA_EVENT[dvTP]
{
	ONLINE:
	    {
		fnClearTextBoxes()
		SEND_COMMAND dvTP,"'@TXT',nText[1],ITOA(nInputSelected)" // update the text box
		SEND_LEVEL dvTP,nLevels[1],nInputLevel[nInputSelected] // update the level graph 
		SEND_COMMAND dvTP,"'@TXT',nText[12],ITOA(nInputLevel[nInputSelected]),' %'" // update the level text
	        SEND_COMMAND dvTP,"'@TXT',nText[2],ITOA(nOutputSelected)" // update the text box
		SEND_LEVEL dvTP,nLevels[2],nOutputLevel[nOutputSelected] // update the level graph
		SEND_COMMAND dvTP,"'@TXT',nText[13],ITOA(nOutputLevel[nOutputSelected]),' %'" // update the level text
	        SEND_COMMAND dvTP,"'@TXT',nText[3],ITOA(nMatrixInputSelected)" // update the text box
		fnUpdateMatrixOutputs(nMatrixInputSelected)
	    }
}
    
DATA_EVENT[vdvTOA_D901]
{

	STRING:
	    {
		IF(bDebug)
		    SEND_STRING 0,"'UI RECEIVED FROM COMM:',DATA.TEXT"
		IF(DATA.TEXT=='RETRIEVING')
		    SEND_COMMAND dvTP,"'@PPN-Wait'"
		ELSE SWITCH(REMOVE_STRING(DATA.TEXT,'=',1))
		{
		    CASE 'LEVEL=':
			{
			    STACK_VAR INTEGER nSource,nValue
			    IF(FIND_STRING(DATA.TEXT,'I:',1))
			    {
				REMOVE_STRING(DATA.TEXT,'I:',1)
				nSource=ATOI(DATA.TEXT)
				REMOVE_STRING(DATA.TEXT,':',1)
				nValue=ATOI(DATA.TEXT)
				nInputLevel[nSource]=nValue
				IF(nSource==nInputSelected && !bDeviceScale) 
				{
				    SEND_LEVEL dvTP,nLevels[1],nInputLevel[nInputSelected] // update the level graph 
			            SEND_COMMAND dvTP,"'@TXT',nText[12],ITOA(nValue),' %'" // update the level text
				}
			    }
			    ELSE
			    {
				REMOVE_STRING(DATA.TEXT,'O:',1)
				nSource=ATOI(DATA.TEXT)
				REMOVE_STRING(DATA.TEXT,':',1)
				nValue=ATOI(DATA.TEXT)
				nOutputLevel[nSource]=nValue
				IF(nSource==nOutputSelected && !bDeviceScale) 
				{
				    SEND_LEVEL dvTP,nLevels[2],nOutputLevel[nOutputSelected] // update the level graph
				    SEND_COMMAND dvTP,"'@TXT',nText[13],ITOA(nValue),' %'" // update the level text
			        }
			    }
			}
			BREAK
		    CASE 'LEVEL_MATRIX=':
			{
			    STACK_VAR INTEGER nSource,nDestination,nLevel
			    IF(FIND_STRING(DATA.TEXT,'I:',1) && FIND_STRING(DATA.TEXT,'O:',1))
			    {
				REMOVE_STRING(DATA.TEXT,'I:',1)
				nSource=ATOI(DATA.TEXT)
				REMOVE_STRING(DATA.TEXT,'O:',1)
				nDestination=ATOI(DATA.TEXT)
				REMOVE_STRING(DATA.TEXT,':',1)
				nLevel=ATOI(DATA.TEXT)
				nMatrixLevel[nSource][nDestination]=nLevel
				IF(nSource==nMatrixInputSelected && !bDeviceScale) 
				    fnUpdateMatrixOutputs(nSource)
			    }
			}
			BREAK
		    CASE 'MUTE=':
			{
			    STACK_VAR INTEGER nSource,nValue
			    IF(FIND_STRING(DATA.TEXT,'I:',1))
			    {
				REMOVE_STRING(DATA.TEXT,'I:',1)
				nSource=ATOI(DATA.TEXT)
				REMOVE_STRING(DATA.TEXT,':',1)
				nValue=ATOI(DATA.TEXT)
				nInputMute[nSource]=nValue
				[dvTP,nButtons[nSource+2]]=(!nInputMute[nSource]) // feedback
			    }
			    ELSE
			    {
				REMOVE_STRING(DATA.TEXT,'O:',1)
				nSource=ATOI(DATA.TEXT)
				REMOVE_STRING(DATA.TEXT,':',1)
				nValue=ATOI(DATA.TEXT)
				nOutputMute[nSource]=nValue
				[dvTP,nButtons[nSource+17]]=(!nOutputMute[nSource]) // feedback
			    }
			}
			BREAK
		    CASE 'RECALL=':
			{
			    REMOVE_STRING(DATA.TEXT,':',1)
			    nPreset = ATOI(DATA.TEXT)
			}
			BREAK
		    CASE 'ONLINE=':
			{
			    [dvTP,nButtons[50]]=ATOI(DATA.TEXT)
			}
			BREAK
		}
	    }

}
BUTTON_EVENT[dvTP,nBUTTONS]
{

	PUSH:
	    {
		nSelection = GET_LAST(nButtons)
		SELECT
		{
		    ACTIVE(nSelection==1): // Input up 
		    {
			nInputSelected++
			IF(nInputSelected>MAX_INPUTS) nInputSelected=1
			SEND_COMMAND dvTP,"'@TXT',nText[1],ITOA(nInputSelected)" // update the text box
			IF(!bDeviceScale)
			{
			    SEND_LEVEL dvTP,nLevels[1],nInputLevel[nInputSelected] // update the level graph
			    SEND_COMMAND dvTP,"'@TXT',nText[12],ITOA(nInputLevel[nInputSelected]),' %'" // update the level text
		        }
		    }
		    ACTIVE(nSelection==2): // Input down 
		    {
			nInputSelected--
			IF(nInputSelected==0) nInputSelected=12
			SEND_COMMAND dvTP,"'@TXT',nText[1],ITOA(nInputSelected)" // update the text box
			IF(!bDeviceScale)
			{
			    SEND_LEVEL dvTP,nLevels[1],nInputLevel[nInputSelected] // update the level graph
			    SEND_COMMAND dvTP,"'@TXT',nText[12],ITOA(nInputLevel[nInputSelected]),' %'" // update the level text
		        }
		    }
		    ACTIVE(nSelection==55): // Input Level up 
		    {
			SEND_COMMAND vdvTOA_D901,"'LEVEL=1:I:',ITOA(nInputSelected),':+'"
		    }
		    ACTIVE(nSelection==56): // Input Level down
		    {
			SEND_COMMAND vdvTOA_D901,"'LEVEL=1:I:',ITOA(nInputSelected),':-'"
		    }
		    ACTIVE(nSelection>=3 && nSelection<=14): // Enable Input
		    {
			SEND_COMMAND vdvTOA_D901,"'MUTE=1:I:',ITOA(nSelection-2),':',ITOA(!nInputMute[nSelection-2])" // toggle
		    }
		    ACTIVE(nSelection==15): // Toggle all Inputs
		    {
			SEND_COMMAND vdvTOA_D901,"'MUTE=1:I:*:',ITOA(!nInputMute[1])" // toggle based on the first input as the seed...
		    }
		    ///////////////////////////////////
		    ACTIVE(nSelection==16): // Output up 
		    {
			nOutputSelected++
			IF(nOutputSelected>MAX_OUTPUTS) nOutputSelected=1
			SEND_COMMAND dvTP,"'@TXT',nText[2],ITOA(nOutputSelected)" // update the text box
			IF(!bDeviceScale)
			{
			    SEND_LEVEL dvTP,nLevels[2],nOutputLevel[nOutputSelected] // update the level graph
			    SEND_COMMAND dvTP,"'@TXT',nText[13],ITOA(nOutputLevel[nOutputSelected]),' %'" // update the level text
		        }
		    }
		    ACTIVE(nSelection==17): // Output down 
		    {
			nOutputSelected--
			IF(nOutputSelected==0) nOutputSelected=8
			SEND_COMMAND dvTP,"'@TXT',nText[2],ITOA(nOutputSelected)" // update the text box
			IF(!bDeviceScale)
			{
			    SEND_LEVEL dvTP,nLevels[2],nOutputLevel[nOutputSelected] // update the level graph
			    SEND_COMMAND dvTP,"'@TXT',nText[13],ITOA(nOutputLevel[nOutputSelected]),' %'" // update the level text
		        }
		    }
		    ACTIVE(nSelection==57): // Output Level up 
		    {
			SEND_COMMAND vdvTOA_D901,"'LEVEL=1:O:',ITOA(nOutputSelected),':+'"
		    }
		    ACTIVE(nSelection==58): // Output Level down
		    {
			SEND_COMMAND vdvTOA_D901,"'LEVEL=1:O:',ITOA(nOutputSelected),':-'"
		    }
		    ACTIVE(nSelection>=18 && nSelection<=25): // Enable Output
		    {
			SEND_COMMAND vdvTOA_D901,"'MUTE=1:O:',ITOA(nSelection-17),':',ITOA(!nOutputMute[nSelection-17])" // toggle
		    }
		    ACTIVE(nSelection==26): // Toggle all Outputs
		    {
			SEND_COMMAND vdvTOA_D901,"'MUTE=1:O:*:',ITOA(!nOutputMute[1])" // toggle based on the first input as the seed...
		    }
		    //////////////////////////////////
		    ACTIVE(nSelection==27): // Matrix Input up 
		    {
			nMatrixInputSelected++
			IF(nMatrixInputSelected>MAX_INPUTS) nMatrixInputSelected=1
			SEND_COMMAND dvTP,"'@TXT',nText[3],ITOA(nMatrixInputSelected)" // update the text box
			fnUpdateMatrixOutputs(nMatrixInputSelected)
		    }
		    ACTIVE(nSelection==28): // Matrix Input down 
		    {
			nMatrixInputSelected--
			IF(nMatrixInputSelected==0) nMatrixInputSelected=12
			SEND_COMMAND dvTP,"'@TXT',nText[3],ITOA(nMatrixInputSelected)" // update the text box
			fnUpdateMatrixOutputs(nMatrixInputSelected) 
		    }
		    ACTIVE(nSelection>=29 && nSelection<=44): // Matrix Output level  
		    {
			IF(nSelection%2) SEND_COMMAND vdvTOA_D901,"'LEVEL_MATRIX=1:I:',ITOA(nMatrixInputSelected),':O:',ITOA((nSelection-27)/2),':+'"
			ELSE SEND_COMMAND vdvTOA_D901,"'LEVEL_MATRIX=1:I:',ITOA(nMatrixInputSelected),':O:',ITOA((nSelection-28)/2),':-'"
		    }
		    /////////////////////////////////
		    ACTIVE(nSelection<=49):
		    {
			SEND_COMMAND vdvTOA_D901,"'RECALL=1:',ITOA(nSelection-44)"
		    }
		    /////////////////////////////////
		    ACTIVE(nSelection<=54):
		    {
			STACK_VAR INTEGER nCnt
			FOR(nCnt=1;nCnt<=4;nCnt++)
			    OFF[dvTP,nButtons[nCnt+50]]
			ON[dvTP,nButtons[nSelection]]
		    }
		    //////////////////////////////////
		    
		    
		}
	    }
	HOLD[2,REPEAT]:
	    {
		SELECT
		{
		    ACTIVE(nSelection==55): // Input Level up 
		    {
			SEND_COMMAND vdvTOA_D901,"'LEVEL=1:I:',ITOA(nInputSelected),':+2'"
		    }
		    ACTIVE(nSelection==56): // Input Level down
		    {
			SEND_COMMAND vdvTOA_D901,"'LEVEL=1:I:',ITOA(nInputSelected),':-2'"
		    }
		    ACTIVE(nSelection==57): // Output Level up 
		    {
			SEND_COMMAND vdvTOA_D901,"'LEVEL=1:O:',ITOA(nOutputSelected),':+2'"
		    }
		    ACTIVE(nSelection==58): // Output Level down
		    {
			SEND_COMMAND vdvTOA_D901,"'LEVEL=1:O:',ITOA(nOutputSelected),':-2'"
		    }
		    ACTIVE(nSelection>=29 && nSelection<=44): // Matrix Output level  
		    {
			IF(nSelection%2) SEND_COMMAND vdvTOA_D901,"'LEVEL_MATRIX=1:I:',ITOA(nMatrixInputSelected),':O:',ITOA((nSelection-27)/2),':+'"
			ELSE SEND_COMMAND vdvTOA_D901,"'LEVEL_MATRIX=1:I:',ITOA(nMatrixInputSelected),':O:',ITOA((nSelection-28)/2),':-'"
		    }
		    
		    
		}
	    }


}

DEFINE_PROGRAM

[dvTP,nButtons[45]]=(nPreset==1)
[dvTP,nButtons[46]]=(nPreset==2)
[dvTP,nButtons[47]]=(nPreset==3)
[dvTP,nButtons[48]]=(nPreset==4)
[dvTP,nButtons[49]]=(nPreset==5)

